# DescribeHostMachineTypeFamilies - DescribeHostMachineTypeFamilies

## Overview

Get a list of instance specification families (information for all models)






## Definition

### Public Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Action**     | string  | Corresponding API command name, the current API is `DescribeHostMachineTypeFamilies`.                      | **Yes** |
| **PublicKey**  | string  | The user's public key can be obtained from [Console](https://console.scloudsg.com/uaccount/api_manage)                                             | **Yes** |
| **Signature**  | string  | User signature generated based on public key and API command, see [Signature Algorithm](/docs/api/summary/signature.md)  | **Yes** |

### Request Parameters

| Parameter Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **ProjectId** | string | Project ID. If not filled in, the default project is used, sub-accounts must be filled in. Please refer to the [GetProjectList interface](/docs/api/summary/get_project_list). |**Yes**|

### Response Field

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **RetCode** | int | Return status code. If it is 0, it means successful return. If it is not 0, it means failure. |**Yes**|
| **Action** | string | Operation command name. |**Yes**|
| **Message** | string | Returns an error message, providing detailed description when `RetCode` is non-zero. |No|
| **MachineTypes** | array[[*MachineTypes*](#machinetypes)] | Machine Types |No|

#### Data Model


#### MachineTypes

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Name |No|
| **Description** | string | Description |No|
| **OperationStatus** | string | OperationStatus |No|
| **CpuPlatforms** | array[[*CpuPlatformStatus*](#cpuplatformstatus)] | Cpu Platforms |No|
| **Disks** | array[[*FamiliesDisks*](#familiesdisks)] | Disks Info |No|
| **MachineSizes** | array[[*MachineSizes*](#machinesizes)] | Machine Sizes |No|
| **Features** | array[[*Features*](#features)] | Features |No|
| **ParentType** | string | Parent type. If the parent type of GPU model is "G" |No|
| **GpuType** | [*FamiliesGpuType*](#familiesgputype) | GPU information |No|
| **SceneCategories** | array[string] | Scene categories |No|
| **GpuSeries** | string | GPU Series |No|
| **UHostFamilies** | array[[*UHostFamily*](#uhostfamily)] | Families information |No|
| **Virtual** | boolean | Virtual |No|
| **ProType** | [*NameFrequency*](#namefrequency) | ProType |No|

#### CpuPlatformStatus

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Cpu Platform |No|
| **OperationStatus** | string | Commpont Code |No|

#### FamiliesDisks

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Disk medium category information, the main categories of disks are as follows: Cloud Disk\|cloudDisk, Normal Local Disk\|normalLocalDisk and SSD Local Disk\|ssdLocalDisk. |No|
| **BootDisk** | array[[*FamiliesBootDiskInfo*](#familiesbootdiskinfo)] | System Disk Information |No|
| **DataDisk** | array[[*FamiliesDataDiskInfo*](#familiesdatadiskinfo)] | Data Disk Information |No|
| **OperationStatus** | string | Operation status |No|

#### MachineSizes

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Gpu** | int | Gpu refers to the specifications that GPU can support, namely the number of GPU cores. For non-GPU models, Gpu is 0. |No|
| **Collection** | array[[*Collection*](#collection)] | Specifications supported by CPU and memory |No|

#### Features

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Supported feature names. Currently supported features are Network Enhancement\|NetCapability, Hot Upgrade\|Hotplug. |No|
| **Modes** | array[[*FeatureModes*](#featuremodes)] | Available mode categories |No|

#### FamiliesGpuType

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Machine Type Name |No|
| **GraphicsMemory** | [*GraphicsMemory*](#graphicsmemory) | Graphics Memory |No|
| **Performance** | [*Performance*](#performance) | Performance |No|

#### UHostFamily

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | UHost Family Name |No|
| **CpuFrequency** | string | CPU Frequency |No|
| **CpuPlatforms** | array[[*CpuPlatformWithModels*](#cpuplatformwithmodels)] | array of CPU Platforms |No|

#### NameFrequency

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Name |No|
| **Frequency** | [*Frequency*](#frequency) | Frequency |No|

#### Frequency

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Value** | float | value |No|

#### CpuPlatformWithModels

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | CPU Platform |No|
| **CpuModels** | array[string] | array of CPU Model |No|
| **CpuFrequency** | string | CPU Frequency |No|

#### GraphicsMemory

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Value** | int | Value, unit is GB |No|
| **Rate** | int | Interactive display parameters, can be ignored |No|

#### Performance

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Value** | float | Value, the unit is TFlops |No|
| **Rate** | int | Interactive display parameters, can be ignored |No|

#### FeatureModes

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Pattern\|Feature Name |No|
| **RelatedToImageFeature** | array[string] | For the tag that supports this feature on the image. For example, the field 'Features' returned by 'DescribeImage' contains 'HotPlug', which indicates that the image supports hot upgrades. |No|
| **MinimalCpuPlatform** | array[string] | This feature is only supported by the CPU platforms and above that are listed. |No|

#### Collection

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Cpu** | int | CPU Specifications |No|
| **Memory** | array[int] | Memory Specification |No|
| **MinimalCpuPlatform** | array[string] | CPU and memory specifications can only be supported on the listed CPU platforms. |No|

#### FamiliesBootDiskInfo

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | System disk category, including ordinary cloud disk\|CLOUD_NORMAL, SSD cloud disk\|CLOUD_SSD and RSSD cloud disk\|CLOUD_RSSD. The ordinary local disk only includes ordinary local disk\|LOCAL_NORMAL. The SSD local disk only includes SSD local disk\|LOCAL_SSD. |No|
| **InstantResize** | boolean | Whether the system disk allows expansion. If it is a local disk, expansion is not allowed, InstantResize is set to false. |No|
| **MaximalSize** | int | MaximalSize is the maximum value of the disk |No|
| **Features** | array[[*DiskFeature*](#diskfeature)] | Services Supported by Disk |No|

#### FamiliesDataDiskInfo

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **MinimalSize** | int | Minimum disk size. If this field is not present, the minimum value defaults to the base image size (20G for Linux, 40G for Windows). |No|
| **Name** | string | Data disk types, including ordinary cloud disk\|CLOUD_NORMAL, SSD cloud disk\|CLOUD_SSD and RSSD cloud disk\|CLOUD_RSSD. The ordinary local disk only includes ordinary local disk\|LOCAL_NORMAL. The SSD local disk only includes SSD local disk\|LOCAL_SSD. |No|
| **MaximalSize** | int | MaximalSize is the maximum value of the disk |No|
| **Features** | array[[*DiskFeature*](#diskfeature)] | Services Supported by Data Disk |No|

#### DiskFeature

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Feature name |No|
| **Modes** | array[[*NameOperationStatus*](#nameoperationstatus)] | Feature modes |No|

#### NameOperationStatus

| Field Name | Type | Description Information | Required |
|:---|:---|:---|:---|
| **Name** | string | Name |No|
| **OperationStatus** | string | OperationStatus |No|

## Example

### Request Example
    
```
https://api.scloudsg.com/?Action=DescribeHostMachineTypeFamilies
&Region=cn-zj
&Zone=cn-zj-01
&ProjectId=FGdvaxgk
&ProjectId=qNFfwyzn
```

### Response Example
    
```json
{
  "Action": "DescribeHostMachineTypeFamiliesResponse",
  "MachineTypes": "WshRTkXT",
  "RetCode": 0
}
```





